<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Awb extends CI_Controller {

	private $f_login 	= NULL;
	private $RSAKey 	= NULL;

	public function __construct() {
		parent::__construct();
		$this->load->library('lo');
		$this->f_login 	= (int)999999;
		$this->RSAKey 	= '';
		$this->load->helper('url');
	}

	public function index() {
		$this->load->view('awb');
	}

	public function generate_awb($action = FALSE) {
		// deoarece continutul call-ului ($f_request_awb) e acelasi pentru generare AWB si estimare pret, am separat doar apelul de metoda pe baza $action
		// pentru generare AWB: $lo->GenerateAwb($f_request_awb);
		// pentru estimare pret: $lo->EstimeazaPret($f_request_awb);

		$f_request_awb = array();
		$f_request_awb['f_shipping_company_id'] 					= (int)43;	 				// int 								obligatoriu  // din interfata de comerciant
		$f_request_awb['request_data_ridicare'] 					= date('Y-m-d');			// date Y-m-d						optional
		$f_request_awb['request_ora_ridicare'] 						= '14:00:00';				// time without time zone H:i:s 	optional
		$f_request_awb['request_ora_ridicare_end'] 					= '14:00:00';				// time without time zone 			optional
		$f_request_awb['request_ora_livrare_sambata'] 				= '14:00:00';				// time without time zone 			optional
		$f_request_awb['request_ora_livrare_end_sambata'] 			= '14:00:00';				// time without time zone 			optional
		$f_request_awb['request_ora_livrare'] 						= '14:00:00';				// time without time zone 			optional
		$f_request_awb['request_ora_livrare_end'] 					= '14:00:00';				// time without time zone 			optional
		$f_request_awb['descriere_livrare'] 						= 'Comanda nr. 3';			// varchar 250						optional
		$f_request_awb['referinta_expeditor'] 						= 'Referinta de test';		// varchar 255						Obligatoriu
		$f_request_awb['valoare_declarata']							= '150.99';					// decimal 10,2 					Obligatoriu
		$f_request_awb['ramburs'] 									= '140.99';					// decimal 10,2 					Obligatoriu
		$f_request_awb['asigurare_la_valoarea_declarata'] 			= FALSE;					// boolean							Obligatoriu
		$f_request_awb['retur_documente'] 							= FALSE;					// boolean 							optional
		$f_request_awb['retur_documente_bancare'] 					= FALSE;					// boolean							optional
		$f_request_awb['confirmare_livrare'] 						= FALSE;					// boolean							optional
		$f_request_awb['livrare_sambata'] 							= FALSE;					// boolean							optional
		$f_request_awb['currency'] 									= 'RON';					// char 							Obligatoriu cand "valoare_declarata" > 0
		$f_request_awb['currency_ramburs'] 							= 'RON';					// char 							Obligatoriu cand "ramburs" > 0
		$f_request_awb['notificare_email'] 							= TRUE;						// boolean							optional
		$f_request_awb['notificare_sms'] 							= TRUE;						// boolean							optional
		$f_request_awb['cine_plateste'] 							= (int)0;					// 0 - merchant,2 - destinatar,1 - expeditor    Obligatoriu
		$f_request_awb['serviciuid'] 								= (int)282;					// int								Obligatoriu  // din lista serviciilor disponibile in interfata de comerciant
		$f_request_awb['request_mpod'] 								= FALSE;					// boolean	 						optional
		$f_request_awb['plateste_rambursul_la_comerciant']  		= (int)2;					// 1 - cash (ramburs), 2 - banca    default 2
		
		$colete = array();

		$colete[] = array(
							'greutate'=>	(float)1.01, 										// decimal 10,2 kg
							'lungime'=>		(int)10,											// integer      cm
							'latime'=>		(int)10,											// integer      cm
							'inaltime'=>	(int)10,											// integer      cm
							'continut'=>	(int)1,												// int      1;"Acte" 2;"Tipizate" 3;"Fragile" 4;"Generale"
							'tipcolet'=>	(int)1,												// int		1;"Plic"2;"Colet"3;"Palet"
						);
		$colete[] = array(
							'greutate'=>	(float)10.01, 										// decimal 10,2 kg
							'lungime'=>		(int)10,											// integer      cm
							'latime'=>		(int)10,											// integer      cm
							'inaltime'=>	(int)10,											// integer      cm
							'continut'=>	(int)1,												// int      1;"Acte" 2;"Tipizate" 3;"Fragile" 4;"Generale"
							'tipcolet'=>	(int)1,												// int		1;"Plic"2;"Colet"3;"Palet"
						);

		$f_request_awb['colete'] = $colete;

		$f_request_awb['destinatar'] = array(																				
										'first_name' 			=> 'test',											//Obligatoriu
										'last_name'				=> 'test',												//Obligatoriu
										'email'					=> 'test@test.com',								//Obligatoriu
										'phone' 				=> '',													//phone sau mobile Obligatoriu
										'mobile'				=> '0741055805',
										'lang' 					=> 'ro',												//Obligatoriu ro/en
										'company_name'			=> 'Companie de test',									//optional
										'j'						=> 'J35/38/2013',										//optional
										'bank_account'			=> 'RO89RNCB1546844678',								//optional
										'bank_name'				=> 'BCR',												//optional
										'cui'					=> '1234567'											//optional
										);

		$f_request_awb['shipTOaddress'] = array(																			//Obligatoriu
										'address1' 				=> 'Str. 2 Cocosi 21',
										'address2'				=> '',
										'city'					=> 'Bucuresti',
										'state' 				=> 'Bucuresti',
										'zip'					=> '800000',
										'country' 				=> 'Romania',
										'phone'					=> '0740000000',
										'observatii'			=> 'Observatii de test'
										);

		$f_request_awb['shipFROMaddress'] = array(
										'email' 				=> 'test@test.com',				//{Email-ul de la Meniul "Settings" -> "Adrese de ridicare"} -- Obligatoriu
										'first_name'			=> 'AAA',														
										'last_name'				=> 'BBB',														
										'mobile'				=> '0741000000',						
										'main_address'			=> 'Adresa principala',										
										'city'					=> 'Bucuresti',							
										'state' 				=> 'Bucuresti',							
										'zip'					=> '3456789',							
										'country' 				=> 'Romania',							
										'phone'					=> '021447414',							
										'instructiuni'			=> 'instructiuni'							
									);

		$lo = new LO();

		//f_login si RSA key vor fi setate in config
		$lo->f_login = $this->f_login; 	// din interfata de comerciant
		$lo->setRSAKey($this->RSAKey);		// din interfata de comerciant
		//end f_login si RSA key vor fi setate in config
		
		$data = array(); // formez array de info ce vor fi trimise in view

		if ($action != 'estimare') { // e generare de AWB
			//generare AWB
			$response_awb 		= $lo->GenerateAwb($f_request_awb);
			$data['response'] 	= $response_awb;
			$data['heading'] 	= 'Generare AWB';
		} else { // e estimare pret livrare
			//estimare pret
			$response_estimare 	= $lo->EstimeazaPret($f_request_awb);
			$data['response'] 	= $response_estimare;
			$data['heading'] 	= 'Estimare pret livrare';
		}
		$data['action']			= $action;
		$this->load->view('generare_awb',$data);
	}

	public function tracking_awb($awb = NULL) {

		if (!$awb) {
			die('Introduceti nr. AWB');
		}

		$lo = new LO();
		//f_login si RSA key vor fi setate in config
		$lo->f_login = $this->f_login; 	// din interfata de comerciant
		$lo->setRSAKey($this->RSAKey);		// din interfata de comerciant
		//end f_login si RSA key vor fi setate in config

		$f_request_tracking = array('awb'=>$awb);
		$response_tracking 	= $lo->Tracking($f_request_tracking);
		
		//raspuns TRACKING
		if (isset($response_tracking->status) && $response_tracking->status == 'error') {
			die($response_tracking->message);
		} else {
			$stare_curenta 	= $response_tracking->f_stare_curenta;
			$istoric 		= $response_tracking->f_istoric;
		}

		$data = array('stare_curenta' => $stare_curenta, 'istoric' => $istoric);
		$this->load->view('tracking_awb', $data);
	}

	public function cancel_awb($awb = NULL) {

		if (!$awb) {
			die('Introduceti nr. AWB');
		}

		$lo = new LO();
		//f_login si RSA key vor fi setate in config
		$lo->f_login = $this->f_login; 	// din interfata de comerciant
		$lo->setRSAKey($this->RSAKey);		// din interfata de comerciant
		//end f_login si RSA key vor fi setate in config

		//CANCEL LIVRARE
		$f_request_cancel 	= array('awb'=>$awb);
		$response_cancel 	= $lo->CancelLivrare($f_request_cancel);
		
		$data = array('response' => $response_cancel, 'awb' => $awb);
		$this->load->view('cancel_awb', $data);
	}

	public function print_awb($awb = NULL) {

		if (!$awb) {
			die('Introduceti nr. AWB');
		}

		$lo = new LO();
		//f_login si RSA key vor fi setate in config
		$lo->f_login = $this->f_login; 	// din interfata de comerciant
		//end f_login si RSA key vor fi setate in config

		//PRINT AWB
		$f_request_print = array('awb'=>$awb);
		$response_print  = $lo->PrintAwb($f_request_print);
		//raspuns PRINT AWB
		echo $response_print;
	}

	public function issn() {
		if (!isset($_POST['F_CRYPT_MESSAGE_ISSN'])) {
			die('F_CRYPT_MESSAGE_ISSN is not set');
		}

		$F_CRYPT_MESSAGE_ISSN = $_POST['F_CRYPT_MESSAGE_ISSN'];

		$lo = new LO();
		//f_login si RSA key vor fi setate in config
		$lo->f_login = $this->f_login; 	// din interfata de comerciant
		$lo->setRSAKey($this->RSAKey);		// din interfata de comerciant
		//end f_login si RSA key vor fi setate in config

		$issn = $lo->decrypt_ISSN($F_CRYPT_MESSAGE_ISSN); //obiect decodat din JSON in clasa LO

		if (!isset($issn) || empty($issn)) {
			die('Hacking attempt!');
		}
		
		//issn este un obiect, cu atributele: f_order_number, f_statusid, f_stamp, f_awb_collection (array de AWB-uri)

		//f_order_number - referinta
		if (isset($issn->f_order_number)) {
			$vF_Ref = $issn->f_order_number;
		} else {
			$error = true;
			die('Parametrul f_order_number lipseste.');
		}
		//f_statusid
		if (isset($issn->f_statusid)) {
			$vF_statusid = $issn->f_statusid;
		} else {
			$error = true;
			die('Parametrul f_statusid lipseste.');
		}
		// f_stamp
		if (isset($issn->f_stamp)) {
			$vF_stamp = $issn->f_stamp;
		} else {
			$error = true;
			die('Parametrul f_stamp lipseste.');
		}
		// f_awb_collection
		if (isset($issn->f_awb_collection)) {
			$vF_AWB = $issn->f_awb_collection; //array de awb-uri
			$vF_AWB = $vF_AWB[0];
		} else {
			$error = true;
			die('Parametrul f_awb lipseste.');
		}

		// Obtine order id
		$raw_vF_Order_Number = explode('nr.', $vF_Ref);
		$vF_Order_Number = trim($raw_vF_Order_Number[1]);

		$stare1='<f_response_code>1</f_response_code>';

		switch ($vF_statusid) {
			case 100: // Preluata de curier de la comerciant - 100
				//procesez starea livrarii si o actualizez in magazin
				break;
			case 130: // Predata in hub - 130
				//procesez starea livrarii si o actualizez in magazin
				break;
			default:
				$stare1='<f_response_code>0</f_response_code>';  // daca nu am procesat raspunsul ISSN notific serverul LO
				break;
		}

		$raspuns_xml = '<?xml version="1.0" encoding="UTF-8" ?>';
		$raspuns_xml .= '<issn>';
		$raspuns_xml .= '<x_order_number>'.$issn->f_order_number.'</x_order_number>';
		$raspuns_xml .= '<merchServerStamp>'.date("Y-m-dTH:m:s").'</merchServerStamp>';
		$raspuns_xml .= $stare1;
		$raspuns_xml .= '</issn>';

		echo $raspuns_xml;
		die();
	}
}
